/*
	AppleEventUtils.c
	
	Functions to simplify Apple event processing
	
	Copyright  1992 by Paul M. Hoffman
	Send feedback to paul.hoffman@um.cc.umich.edu
	
	This source code may be freely used, altered, and distributed in any way as long as:
		1.	It is GIVEN away rather than sold (except as expressly permitted by the author)
		2.	This statement and the above copyright notice are left intact.
	
	Created	11 Jul 1992	Extracted GetFSSpecsFromAEDescList from Dragon.c
	Modified	12 Sep 1992	Removed GetFSSpecsFromAEDescList  it's no longer needed in Dragonsmith
	
*/

#include	"AppleEventUtils.h"
#include	"HandleUtils.h"

OSErr GotRequiredParams (AppleEvent *theEvent)
{
	DescType	returnedType;
	long			actualSize;
	OSErr		err;
	
	err = AEGetAttributePtr (theEvent, keyMissedKeywordAttr, typeWildCard, &returnedType, NULL, 0, &actualSize);
	if (err == errAEDescNotFound)
		return noErr;
	else if (err == noErr)
		return errAEEventNotHandled;
	else
		return err;
}

